<?xml version="1.0" encoding="UTF-8"?>
<jsp:root xmlns:jsp="http://java.sun.com/JSP/Page"
	  xmlns:c="http://java.sun.com/jsp/jstl/core"
	  xmlns:fmt="http://java.sun.com/jsp/jstl/fmt"
	  xmlns:fn="http://java.sun.com/jsp/jstl/functions"
	  version="2.0">

    <jsp:directive.attribute name="podnik" type="java.lang.Integer" required="true" description="ID podniku"/>
    <jsp:directive.attribute name="hlasuAno" type="java.lang.Integer" required="false" description="počet hlasů pro ano – aby se tu kouřilo"/>
    <jsp:directive.attribute name="hlasuNe" type="java.lang.Integer" required="false" description="počet hlasů pro ne – aby se tu nekouřilo"/>
    <jsp:directive.attribute name="svgUvnitrXhtml" type="java.lang.Boolean" required="false" description="true = SVG vložené přímo do XHTML (XML) | false = SVG jako externí obrázek – &lt;img src='…'/&gt;"/>

    <!-- výchozí hodnota -->
    <c:if test="${svgUvnitrXhtml == null}">
	<c:set var="svgUvnitrXhtml" value="${true}"/>
    </c:if>

    <!-- hodnoty nejsou uvedeny → načteme si je -->
    <c:if test="${hlasuAno == null || hlasuNe == null || (hlasuAno == 0 &amp;&amp; hlasuNe == 0)}">
	<jsp:useBean id="hlasovani" class="cz.frantovo.nekurak.web.Hlasovani" scope="request"/>
	<jsp:setProperty name="hlasovani" property="podnik" value="${podnik}"/>
	<c:set var="hlasuAno" value="${hlasovani.vysledek.hlasuAno}"/>
	<c:set var="hlasuNe" value="${hlasovani.vysledek.hlasuNe}"/>
    </c:if>

    <c:choose>
	<c:when test="${svgUvnitrXhtml}">
	    <svg:svg xmlns:svg="http://www.w3.org/2000/svg"
		     xmlns:xlink="http://www.w3.org/1999/xlink"
		     version="1.1" baseProfile="full"
		     width="200" height="200">


		<svg:style type="text/css">
		    rect.ne {
			fill:  url(#ne_prechod_${podnik});
			stroke: black;
		    }
		    rect.ano {
			fill: url(#ano_prechod_${podnik});
			stroke: black;
		    }

		    a:hover rect.ano, a:hover rect.ne {
			fill: url(#zvyrazneny_prechod_${podnik});
		    }

		    a:hover text {
			fill: green;
		    }

		    line.ramecek {
			stroke: black;
			stroke-width: 2;
		    }


		    rect.pozadi {
			fill: url(#pozadi_prechod_${podnik});
		    }

		    text {
			font-size: 12px;
			font-family: Sans;
		    }

		</svg:style>

		<!-- pozadí – přechod -->
		<svg:defs>
		    <svg:linearGradient id="pozadi_prechod_${podnik}" x1="0%" y1="0%" x2="100%" y2="100%">
			<svg:stop offset="20%" style="stop-color:rgb(245,245,255); stop-opacity:0.5"/>
			<svg:stop offset="100%" style="stop-color:silver; stop-opacity:0.8"/>
		    </svg:linearGradient>
		</svg:defs>

		<!-- nekuřácký graf – přechod -->
		<svg:defs>
		    <svg:linearGradient id="ne_prechod_${podnik}" x1="0%" y1="0%" x2="100%" y2="100%">
			<svg:stop offset="0%" style="stop-color:white; stop-opacity:1"/>
			<svg:stop offset="100%" style="stop-color:blue; stop-opacity:1"/>
		    </svg:linearGradient>
		</svg:defs>

		<!-- zvýrazněný graf – přechod -->
		<svg:defs>
		    <svg:linearGradient id="zvyrazneny_prechod_${podnik}" x1="0%" y1="0%" x2="100%" y2="100%">
			<svg:stop offset="0%" style="stop-color:white; stop-opacity:1"/>
			<svg:stop offset="100%" style="stop-color:green; stop-opacity:1"/>
		    </svg:linearGradient>
		</svg:defs>

		<!-- kuřácký graf – přechod -->
		<svg:defs>
		    <svg:linearGradient id="ano_prechod_${podnik}" x1="0%" y1="0%" x2="100%" y2="100%">
			<svg:stop offset="0%" style="stop-color:white; stop-opacity:1"/>
			<svg:stop offset="100%" style="stop-color:red; stop-opacity:1"/>
		    </svg:linearGradient>
		</svg:defs>

		<!-- pozadí a linka -->
		<svg:rect x="0" y="0" width="200" height="200" class="pozadi"/>
		<svg:line x1="10" y1="180" x2="190" y2="180" class="ramecek"/>

		<!-- nadpis grafu -->
		<svg:text x="60" y="20"><fmt:message key="hlasovani.graf.nadpis"/>:</svg:text>

		<!-- žádné hlasy -->
		<c:if test="${hlasuAno == 0 &amp;&amp; hlasuNe == 0}">
		    <svg:text x="30" y="100"><fmt:message key="hlasovani.graf.zadneHlasy"/></svg:text>
		</c:if>

		<!-- vypočteme si výšky sloupců grafu -->
		<c:set var="hlasuNeVyska" value="${150*hlasuNe/(hlasuAno+hlasuNe)}"/>
		<c:set var="hlasuAnoVyska" value="${150*hlasuAno/(hlasuAno+hlasuNe)}"/>

		<!-- nekuřáci -->
		<fmt:message key="hlasovani.graf.popisSloupce" var="hlasuNeLokalizace">
		    <fmt:param value="${hlasuNe}"/>
		</fmt:message>
		<svg:a xlink:href="javascript:hlasovani.hlasuj(${podnik}, false);" xlink:title="${hlasuNeLokalizace}">
		    <svg:text x="30" y="195" class="ne"><fmt:message key="hlasovani.graf.nekourit"/></svg:text>
		    <svg:rect x="30" y="${180 - hlasuNeVyska}" width="50" height="${hlasuNeVyska}" class="ne"/>
		</svg:a>

		<!-- kuřáci -->
		<fmt:message key="hlasovani.graf.popisSloupce" var="hlasuAnoLokalizace">
		    <fmt:param value="${hlasuAno}"/>
		</fmt:message>
		<svg:a xlink:href="javascript:hlasovani.hlasuj(${podnik}, true);" xlink:title="${hlasuAnoLokalizace}">
		    <svg:text x="130" y="195" class="ano"><fmt:message key="hlasovani.graf.kourit"/></svg:text>
		    <svg:rect x="120" y="${180 - hlasuAnoVyska}" width="50" height="${hlasuAnoVyska}" class="ano"/>
		</svg:a>
	    </svg:svg>
	</c:when>
	<c:otherwise>
	    <object data="hlasovani-svg.jsp?podnik=${podnik}&amp;amp;hlasuAno=${hlasuAno}&amp;amp;hlasuNe=${hlasuNe}" type="image/svg+xml"/>
	</c:otherwise>
    </c:choose>

</jsp:root>